package scorch;

/*
  Class:  Network
  Author: Mikhail Kruk
  Description: network interface for both real server interaction and dummy
  network for single player games
*/

import java.io.*;
import java.net.*;
import java.util.*;

import scorch.utility.*;
import scorch.Protocol;

public interface Network extends Runnable
{
    public void sendMessage(String s);
    public void run();
    public void sendLogin(PlayerProfile profile, String options);
    public void sendNewUser(PlayerProfile profile, String options);
    public void sendMaxPlayers(int maxPlayers);
    public void sendAIPlayer(String player);
    public void sendPlayerSettings(int id, PlayerSettings pSettings);
    public void sendGameSettings(GameSettings gSettings);
    public void sendShout(String msg, String player, int idx);
    public void sendUpdate(int id, int power, int angle);
    public void sendEOT(String dt);
    public void sendUseWeapon(int w_id);
    public void sendUseItem(int i_id, int param);
    public void sendTankDead(int id);
    public void sendMassKill();
    public void sendUpdateUser(PlayerProfile profile, boolean encrypt);
    public void sendTopTen();
    public void quit();
	public void bootPlayer(int id);
}
