package scorch.weapons;

import java.awt.Rectangle;
import java.util.Random;

import scorch.Bitmap;
import scorch.ScorchApplet;
import scorch.ScorchPlayer;

/*
  Author: Charles McCann

  Description: 
  DirtBall explodes into a circle then falls to ground
*/

public class DirtBallExplosion extends RoundExplosion {

	public static int RADIUS = 50;
	private int sand = -1; // sand color
	private int fillCounter = 0;
	private static int sndEXPL;

	public DirtBallExplosion() {
	}

	public DirtBallExplosion(Bitmap bitmap, int radius) {
		this(bitmap, 0, 0, radius);
	}

	public DirtBallExplosion(Bitmap bitmap, int x, int y, int radius) {
		super(bitmap);

		setPosition(x, y);
		setArgument(radius);
		ei = null;
	}

	public void setArgument(int arg) {
		radius = arg; //arg;
	}

	/*
	public void setStepSize(int stepSize) {
		step_size = stepSize;
	}
	*/

	// override parent method to prevent dirt from causing damage
	public int calculateDamage(ScorchPlayer sp) {
		return 0;
	}

	public Rectangle getUpdatedArea() {
		return new Rectangle(x - radius, y - radius, radius * 2, radius * 2);
	}

	public static void loadSounds(ScorchApplet owner) {
		sndEXPL =
			addSound(owner.getAudioClip(owner.getCodeBase(), "Sound/explosion.au"));
	}

	public boolean drawNextFrame(boolean update) {
		if (sand == -1)
			sand = bitmap.getSandColor();

		bitmap.setDensity(0.2f);

		bitmap.setColor(sand);

		if (fillCounter == 0)
			startSound(sndEXPL);
		if (fillCounter < radius) {
			bitmap.fillCircle(x, y, fillCounter);
			fillCounter += 3;
			bitmap.newPixels(x-radius,y-radius,radius*2+1,radius*2+1);
			//bitmap.setDensity(1);
			return true;
		}
		
		
		bitmap.setDensity(1);
		return false;

	}
}

